<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::rmutex Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1rmutex.html">rmutex</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1rmutex-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::rmutex Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a34f186eb1e3eaacd81325a051b4a8142"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1rmutex.html#a34f186eb1e3eaacd81325a051b4a8142">rmutex</a> ()</td></tr>
<tr class="separator:a34f186eb1e3eaacd81325a051b4a8142"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afe3749b745ca5a7fbb58a379d5242550"><td class="memItemLeft" align="right" valign="top"><a id="afe3749b745ca5a7fbb58a379d5242550"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>lock_count</b> () const</td></tr>
<tr class="separator:afe3749b745ca5a7fbb58a379d5242550"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a79103811806733ff40f327f9804012ea"><td class="memItemLeft" align="right" valign="top"><a id="a79103811806733ff40f327f9804012ea"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>lock</b> (unsigned long times=1) const</td></tr>
<tr class="separator:a79103811806733ff40f327f9804012ea"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aed48e045479da8350d03fcab7e22e9e1"><td class="memItemLeft" align="right" valign="top"><a id="aed48e045479da8350d03fcab7e22e9e1"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>unlock</b> (unsigned long times=1) const</td></tr>
<tr class="separator:aed48e045479da8350d03fcab7e22e9e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a38960daa66f5118d980be732def9d023"><td class="memItemLeft" align="right" valign="top"><a id="a38960daa66f5118d980be732def9d023"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>rmutex</b> (<a class="el" href="classdlib_1_1rmutex.html">rmutex</a> &amp;)</td></tr>
<tr class="separator:a38960daa66f5118d980be732def9d023"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0ed151161f33ec18c6dee0ae15b1d8f0"><td class="memItemLeft" align="right" valign="top"><a id="a0ed151161f33ec18c6dee0ae15b1d8f0"></a>
<a class="el" href="classdlib_1_1rmutex.html">rmutex</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1rmutex.html">rmutex</a> &amp;)</td></tr>
<tr class="separator:a0ed151161f33ec18c6dee0ae15b1d8f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:ae89a3eeb8a79b406c1d6a5b11026ec35"><td class="memItemLeft" align="right" valign="top"><a id="ae89a3eeb8a79b406c1d6a5b11026ec35"></a>
<a class="el" href="classdlib_1_1mutex.html">mutex</a>&#160;</td><td class="memItemRight" valign="bottom"><b>m</b></td></tr>
<tr class="separator:ae89a3eeb8a79b406c1d6a5b11026ec35"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a869fa54feb178e818cf854ac76060d3b"><td class="memItemLeft" align="right" valign="top"><a id="a869fa54feb178e818cf854ac76060d3b"></a>
<a class="el" href="classdlib_1_1signaler.html">signaler</a>&#160;</td><td class="memItemRight" valign="bottom"><b>s</b></td></tr>
<tr class="separator:a869fa54feb178e818cf854ac76060d3b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7556c3718fbfe80363d6b4e0a261d324"><td class="memItemLeft" align="right" valign="top"><a id="a7556c3718fbfe80363d6b4e0a261d324"></a>
thread_id_type&#160;</td><td class="memItemRight" valign="bottom"><b>thread_id</b></td></tr>
<tr class="separator:a7556c3718fbfe80363d6b4e0a261d324"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab77d816e4fe388d5a9e5dbc14cfb9021"><td class="memItemLeft" align="right" valign="top"><a id="ab77d816e4fe388d5a9e5dbc14cfb9021"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>count</b></td></tr>
<tr class="separator:ab77d816e4fe388d5a9e5dbc14cfb9021"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a34f186eb1e3eaacd81325a051b4a8142"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a34f186eb1e3eaacd81325a051b4a8142">&#9670;&nbsp;</a></span>rmutex()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">dlib::rmutex::rmutex </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">INITIAL VALUE
    count == 0
    thread_id == 0

CONVENTION
    - count == lock_count()

    - if (no thread currently has a lock on this mutex) then
        - count == 0
    - else
        - count == the number of times the thread that owns this mutex has
          called lock()
        - thread_id == the id of this thread.
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="rmutex__extension_8h_source.html">rmutex_extension.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
